import type { INPUT_METHOD } from '@atlaskit/editor-common/analytics';
import type { EditorCommand, NextEditorPlugin, OptionalPlugin } from '@atlaskit/editor-common/types';
import type { AnalyticsPlugin } from '@atlaskit/editor-plugin-analytics';
import type { PrimaryToolbarPlugin } from '@atlaskit/editor-plugin-primary-toolbar';
import type { TextFormattingPlugin } from '@atlaskit/editor-plugin-text-formatting';
import type { HighlightPluginState } from './pm-plugins/main';
export type HighlightPluginOptions = {
    textHighlightingFloatingToolbarExperiment?: boolean;
};
export type HighlightPlugin = NextEditorPlugin<'highlight', {
    pluginConfiguration?: HighlightPluginOptions;
    dependencies: [
        OptionalPlugin<AnalyticsPlugin>,
        OptionalPlugin<TextFormattingPlugin>,
        OptionalPlugin<PrimaryToolbarPlugin>
    ];
    sharedState: HighlightPluginState | undefined;
    commands: {
        changeColor: ({ color }: {
            color: string;
            inputMethod: INPUT_METHOD;
        }) => EditorCommand;
    };
}>;
export declare const highlightPlugin: HighlightPlugin;
